import Avido from 'avido';const client = new Avido({ apiKey: process.env['AVIDO_API_KEY'], // This is the default and can be omitted applicationID: process.env['AVIDO_APPLICATION_ID'], // This is the default and can be omitted});const ingest = await client.ingest.create({ events: [ { type: 'trace' }, { event: 'start', input: [{ role: 'user', content: 'Tell me a joke.' }], modelId: 'gpt-4o-2024-08-06', type: 'llm', }, ],});console.log(ingest.data);
import os
from avido import Avido
client = Avido(
api_key=os.environ.get("AVIDO_API_KEY"), # This is the default and can be omitted
application_id=os.environ.get("AVIDO_APPLICATION_ID"), # This is the default and can be omitted
)
ingest = client.ingest.create(
events=[{
"type": "trace"
}, {
"event": "start",
"input": [{
"role": "user",
"content": "Tell me a joke.",
}],
"model_id": "gpt-4o-2024-08-06",
"type": "llm",
}],
)
print(ingest.data)
Ingest an array of events (traces or steps) to store and process.
POST
/
v0
/
ingest
JavaScript
import Avido from 'avido';const client = new Avido({ apiKey: process.env['AVIDO_API_KEY'], // This is the default and can be omitted applicationID: process.env['AVIDO_APPLICATION_ID'], // This is the default and can be omitted});const ingest = await client.ingest.create({ events: [ { type: 'trace' }, { event: 'start', input: [{ role: 'user', content: 'Tell me a joke.' }], modelId: 'gpt-4o-2024-08-06', type: 'llm', }, ],});console.log(ingest.data);
import os
from avido import Avido
client = Avido(
api_key=os.environ.get("AVIDO_API_KEY"), # This is the default and can be omitted
application_id=os.environ.get("AVIDO_APPLICATION_ID"), # This is the default and can be omitted
)
ingest = client.ingest.create(
events=[{
"type": "trace"
}, {
"event": "start",
"input": [{
"role": "user",
"content": "Tell me a joke.",
}],
"model_id": "gpt-4o-2024-08-06",
"type": "llm",
}],
)
print(ingest.data)
Array of events to be ingested, which can be traces or steps.
An event represents one step in the interaction with your AI application, such as a RAG call, reranker, tool call, LLM trigger, agent orchestration, embedding, guardrail check, evaluator, response, or user request.
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"Avido","colors":{"primary":"#FF7514","light":"#FF7514","dark":"#803B0A"},"logo":{"light":"https://mintcdn.com/avido/XZVUP7f9J0DVOGvD/images/logo.svg?fit=max\u0026auto=format\u0026n=XZVUP7f9J0DVOGvD\u0026q=85\u0026s=b268bcb717a1c694344be5a48e5ede72","dark":"https://mintcdn.com/avido/XZVUP7f9J0DVOGvD/images/logo.svg?fit=max\u0026auto=format\u0026n=XZVUP7f9J0DVOGvD\u0026q=85\u0026s=b268bcb717a1c694344be5a48e5ede72","href":"https://avidoai.com"},"favicon":"https://mintcdn.com/avido/XZVUP7f9J0DVOGvD/images/logo.svg?fit=max\u0026auto=format\u0026n=XZVUP7f9J0DVOGvD\u0026q=85\u0026s=b268bcb717a1c694344be5a48e5ede72","navbar":{"links":[{"href":"mailto:support@avidoai.com","label":"Support"}],"primary":{"type":"button","label":"Dashboard","href":"https://app.avidoai.com"}},"footer":{"socials":{"x":"https://x.com/avidoai","github":"https://github.com/avido-ai","linkedin":"https://www.linkedin.com/company/avidoai"}},"fonts":{"family":"Geist","weight":400,"format":"woff2"},"styling":{"latex":false},"navigation":{"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"avido","hasAudioNarration":false,"actualSubdomain":"avido","customDomains":["docs.avidoai.com"],"gitSource":{"type":"github","owner":"avido-ai","repo":"avido","deployBranch":"main","contentDirectory":"apps/docs","isPrivate":true,"mountPath":"","label":""},"entitlements":{},"buildId":"6a98bb90b0c4d98bad4c728b","clientVersion":"0.0.4102","searchFilterCounts":[{"language":"default","tag":"Documentation","count":236},{"language":"default","tag":"API Reference","count":210},{"language":"default","tag":"Documents","count":20},{"language":"default","tag":"Reports","count":15},{"language":"default","tag":"Tasks","count":15},{"language":"default","tag":"Eval Definitions","count":12},{"language":"default","tag":"QuickstartsV2","count":12},{"language":"default","tag":"Issues","count":9},{"language":"default","tag":"Topics","count":9},{"language":"default","tag":"Experiments","count":8}]},"assistantConfig":{},"basePath":"","hasChatPermissions":false,"hasWebMcpPermissions":false,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-rbac-roles","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"rbac-expansion","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"full-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-dual-write","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"approve-review-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-metadata","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"sso-setup-deadline-banner","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-serve","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"live-agents","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"googleFontsInlined":true},"customCss":[],"page":{"pagePath":"api-reference/ingestion/ingest-events","slug":"/api-reference/ingestion/ingest-events","pageMetadata":{"title":"Ingest events","description":"Ingest an array of events (traces or steps) to store and process.","deprecated":null,"version":null,"openapi":"https://app.stainless.com/api/spec/documented/avido/openapi.documented.yml post /v0/ingest","href":"/api-reference/ingestion/ingest-events","autogeneratedByOpenApi":true},"description":{"compiledSource":"\"use strict\";\nconst {jsx: _jsx} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n p: \"p\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsx(_components.p, {\n children: \"Ingest an array of events (traces or steps) to store and process.\"\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){return _jsx(_Fragment,{})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Ingest events","description":"Ingest an array of events (traces or steps) to store and process.","deprecated":null,"version":null,"openapi":"https://app.stainless.com/api/spec/documented/avido/openapi.documented.yml post /v0/ingest","href":"/api-reference/ingestion/ingest-events","autogeneratedByOpenApi":true}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[],"codeExamples":{}},"jsLinks":[],"openApiReferenceData":{"operation":{"operationId":"postIngest","summary":"Ingest events","description":"Ingest an array of events (traces or steps) to store and process.","tags":["Ingestion"],"requestBody":"3587a66a-6563-4909-b057-fb2b5cd9fecb","responses":{"200":"963dd7df-b6ac-49a5-875f-7fe925794f05","400":"73f07e9e-a4bc-4f30-93ee-5cc6b5a20684","401":"02ebfbaa-9932-4a2e-9d50-6d689ad57c82","403":"f2eca9d0-56a3-40dd-a103-eb5112866387","422":"e4e1c534-5758-42fb-8775-a0987f3084a2","500":"32e625f8-1740-44aa-9dfc-b025101adec1"},"x-codeSamples":[{"lang":"JavaScript","source":"import Avido from 'avido';\n\nconst client = new Avido({\n apiKey: process.env['AVIDO_API_KEY'], // This is the default and can be omitted\n applicationID: process.env['AVIDO_APPLICATION_ID'], // This is the default and can be omitted\n});\n\nconst ingest = await client.ingest.create({\n events: [\n { type: 'trace' },\n {\n event: 'start',\n input: [{ role: 'user', content: 'Tell me a joke.' }],\n modelId: 'gpt-4o-2024-08-06',\n type: 'llm',\n },\n ],\n});\n\nconsole.log(ingest.data);"},{"lang":"Python","source":"import os\nfrom avido import Avido\n\nclient = Avido(\n api_key=os.environ.get(\"AVIDO_API_KEY\"), # This is the default and can be omitted\n application_id=os.environ.get(\"AVIDO_APPLICATION_ID\"), # This is the default and can be omitted\n)\ningest = client.ingest.create(\n events=[{\n \"type\": \"trace\"\n }, {\n \"event\": \"start\",\n \"input\": [{\n \"role\": \"user\",\n \"content\": \"Tell me a joke.\",\n }],\n \"model_id\": \"gpt-4o-2024-08-06\",\n \"type\": \"llm\",\n }],\n)\nprint(ingest.data)"}],"method":"post","type":"path","servers":["4f236849-7374-466a-8918-4cd00576ab95"],"security":["7bf9289a-dbe8-45a8-acf7-c0f9d38ed7de"],"path":"/v0/ingest","baseUrlOptions":["https://api.avidoai.com"],"title":"Ingest events","codeSamples":[{"lang":"JavaScript","source":"import Avido from 'avido';\n\nconst client = new Avido({\n apiKey: process.env['AVIDO_API_KEY'], // This is the default and can be omitted\n applicationID: process.env['AVIDO_APPLICATION_ID'], // This is the default and can be omitted\n});\n\nconst ingest = await client.ingest.create({\n events: [\n { type: 'trace' },\n {\n event: 'start',\n input: [{ role: 'user', content: 'Tell me a joke.' }],\n modelId: 'gpt-4o-2024-08-06',\n type: 'llm',\n },\n ],\n});\n\nconsole.log(ingest.data);"},{"lang":"Python","source":"import os\nfrom avido import Avido\n\nclient = Avido(\n api_key=os.environ.get(\"AVIDO_API_KEY\"), # This is the default and can be omitted\n application_id=os.environ.get(\"AVIDO_APPLICATION_ID\"), # This is the default and can be omitted\n)\ningest = client.ingest.create(\n events=[{\n \"type\": \"trace\"\n }, {\n \"event\": \"start\",\n \"input\": [{\n \"role\": \"user\",\n \"content\": \"Tell me a joke.\",\n }],\n \"model_id\": \"gpt-4o-2024-08-06\",\n \"type\": \"llm\",\n }],\n)\nprint(ingest.data)"}],"requiredOnlyExamples":false,"requestExampleType":"codeSamples","responseExampleType":"generated"},"dependencies":{"parameters":{},"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"events":{"type":"array","items":{"oneOf":[{"type":"object","title":"Ingest Event","description":"An event represents one step in the interaction with your AI application, such as a RAG call, reranker, tool call, LLM trigger, agent orchestration, embedding, guardrail check, evaluator, response, or user request.","required":["type"],"properties":{"type":{"type":"string","const":"trace","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.type","typeLabel":"string"},"referenceId":{"description":"An optional reference ID to link the trace to an existing conversation or interaction in your own database.","example":"123e4567-e89b-12d3-a456-426614174000","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.referenceId","typeLabel":"string"},"timestamp":{"description":"When the trace was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.timestamp","typeLabel":"string\u003cdate-time>"},"metadata":{"oneOf":[{"type":"string","description":"Arbitrary metadata for this trace (e.g., userId, source, etc.).","example":{"userId":"123","source":"chatbot"},"uniqueKey":"events.items.[INDEX].oneOf.0.metadata.oneOf.0","typeLabel":"string"},{"type":"object","description":"Arbitrary metadata for this trace (e.g., userId, source, etc.).","example":{"userId":"123","source":"chatbot"},"additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.metadata.oneOf.1.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.metadata.oneOf.1","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.metadata.oneOf.2.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary metadata for this trace (e.g., userId, source, etc.).","example":{"userId":"123","source":"chatbot"},"uniqueKey":"events.items.[INDEX].oneOf.0.metadata.oneOf.2","typeLabel":"any[]"}],"uniqueKey":"events.items.[INDEX].oneOf.0.metadata","typeLabel":"string | object | any[]"},"testId":{"description":"The associated Test if this was triggered by an Avido eval","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.testId","typeLabel":"string\u003cuuid>"},"totalCost":{"description":"Total cost of all steps in this trace (sum of step costAmount values).","example":0.0023,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.totalCost","typeLabel":"number"},"totalPromptTokens":{"description":"Total number of prompt tokens used across all LLM steps in this trace.","example":150,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.totalPromptTokens","typeLabel":"integer"},"totalCompletionTokens":{"description":"Total number of completion tokens used across all LLM steps in this trace.","example":200,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.totalCompletionTokens","typeLabel":"integer"},"totalDurationMs":{"description":"Total duration of the trace in milliseconds (sum of all step durations).","example":1500,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.totalDurationMs","typeLabel":"integer"},"hasError":{"description":"Whether any step in this trace has an error status.","example":false,"type":"boolean","uniqueKey":"events.items.[INDEX].oneOf.0.hasError","typeLabel":"boolean"},"stepCount":{"description":"Total number of steps in this trace.","example":5,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.stepCount","typeLabel":"integer"},"steps":{"description":"The steps associated with the trace.","type":"array","items":{"oneOf":[{"type":"object","title":"LLM Start Trace","description":"Start of an LLM trace.","required":["id","traceId","type","modelId","event","input"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"llm","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.type","typeLabel":"string"},"modelId":{"type":"string","description":"Model ID or name used for the LLM call.","example":"gpt-4o-2024-08-06","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.modelId","typeLabel":"string"},"event":{"type":"string","const":"start","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.event","typeLabel":"string"},"input":{"type":"string","description":"JSON input for this LLM trace event (e.g., the prompt).","example":"Tell me a joke.","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.input","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0.error","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.0","typeLabel":"LLM Start Trace · object"},{"type":"object","title":"LLM End Trace","description":"End of an LLM trace.","required":["id","traceId","type","modelId","event"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"llm","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.type","typeLabel":"string"},"modelId":{"type":"string","description":"Model ID or name used for the LLM call.","example":"gpt-4o-2024-08-06","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.modelId","typeLabel":"string"},"event":{"type":"string","const":"end","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.event","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.error","typeLabel":"string"},"output":{"description":"JSON describing the output. String inputs are parsed or wrapped in { message: val }.","example":"Why did the chicken cross the road?","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.output","typeLabel":"string"},"usage":{"type":"object","properties":{"promptTokens":{"type":"integer","minimum":0,"maximum":9007199254740991,"description":"Number of prompt tokens used by the LLM.","example":100,"isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.usage.promptTokens","typeLabel":"integer"},"completionTokens":{"type":"integer","minimum":0,"maximum":9007199254740991,"description":"Number of completion tokens used by the LLM.","example":100,"isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.usage.completionTokens","typeLabel":"integer"}},"required":["promptTokens","completionTokens"],"description":"Number of input and output tokens used by the LLM.","example":{"promptTokens":100,"completionTokens":100},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.usage","typeLabel":"object"},"finishReason":{"description":"The reason the LLM stopped generating, extracted from gen_ai.response.finish_reasons.","example":"stop","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1.finishReason","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.1","typeLabel":"LLM End Trace · object"},{"type":"object","title":"Tool Step","description":"Track all tool calls using the Tool Step event","required":["id","traceId","type"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"tool","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.type","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.error","typeLabel":"string"},"toolCallId":{"description":"Correlation ID from the LLM's tool_calls response (e.g., OpenAI's call_abc123 or Claude's toolu_01A09q). Links tool execution to the originating LLM request in parallel tool call scenarios.","example":"call_abc123","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.toolCallId","typeLabel":"string"},"toolInput":{"description":"JSON input for the tool call.","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.toolInput","typeLabel":"string"},"toolOutput":{"description":"JSON output from the tool call.","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2.toolOutput","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.2","typeLabel":"Tool Step · object"},{"type":"object","title":"Retriever Step","description":"Track all retriever (RAG) calls using the Retriever Step event.","required":["id","traceId","type","query","result"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"retriever","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.type","typeLabel":"string"},"query":{"type":"string","description":"Query used for RAG.","example":"What is the capital of France?","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.query","typeLabel":"string"},"result":{"type":"string","description":"Retrieved text","example":"Paris is the capital of France.","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.result","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3.error","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.3","typeLabel":"Retriever Step · object"},{"type":"object","title":"Reranker Step","description":"Track document reranking operations using the Reranker Step event.","required":["id","traceId","type"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"reranker","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.type","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4.error","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.4","typeLabel":"Reranker Step · object"},{"type":"object","title":"Agent Step","description":"Track agent orchestration and planning using the Agent Step event.","required":["id","traceId","type"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"agent","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.type","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.error","typeLabel":"string"},"input":{"description":"Agent input (JSON).","example":"{\"messages\":[{\"content\":\"What is AI?\",\"type\":\"human\"}]}","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.input","typeLabel":"string"},"output":{"description":"Agent output (JSON).","example":"{\"messages\":[{\"content\":\"What is AI?\",\"type\":\"human\"},{\"content\":\"AI is artificial intelligence...\",\"type\":\"ai\"}]}","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5.output","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.5","typeLabel":"Agent Step · object"},{"type":"object","title":"Embedding Step","description":"Track text embedding operations using the Embedding Step event.","required":["id","traceId","type"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"embedding","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.type","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6.error","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.6","typeLabel":"Embedding Step · object"},{"type":"object","title":"Guardrail Step","description":"Track safety and policy checks using the Guardrail Step event.","required":["id","traceId","type"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"guardrail","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.type","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.error","typeLabel":"string"},"guardrailTriggered":{"description":"True when the guardrail blocked or modified the operation. Sourced from the guardrail.triggered span attribute.","example":true,"type":"boolean","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.guardrailTriggered","typeLabel":"boolean"},"guardrailType":{"description":"Guardrail category (e.g. 'input', 'output', 'input_scope'). Sourced from guardrail.type.","example":"input_scope","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.guardrailType","typeLabel":"string"},"guardrailAction":{"description":"Action the guardrail took (e.g. 'block', 'allow', 'rewrite'). Sourced from guardrail.action.","example":"block","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7.guardrailAction","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.7","typeLabel":"Guardrail Step · object"},{"type":"object","title":"Evaluator Step","description":"Track evaluation operations using the Evaluator Step event.","required":["id","traceId","type"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"evaluator","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.type","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.error","typeLabel":"string"},"evaluatorName":{"description":"Name of the evaluator.","example":"helpfulness","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.evaluatorName","typeLabel":"string"},"evaluationLabel":{"description":"Classification label from the evaluation.","example":"helpful","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.evaluationLabel","typeLabel":"string"},"evaluationScore":{"description":"Numerical score from the evaluation (0-1 range).","example":0.75,"type":"number","minimum":0,"maximum":1,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.evaluationScore","typeLabel":"number"},"evaluationExplanation":{"description":"Detailed explanation of the evaluation result.","example":"The response directly answers the question with clear, organized information.","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8.evaluationExplanation","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.8","typeLabel":"Evaluator Step · object"},{"type":"object","title":"Log Step","description":"Track all logs using the Log Step event.","required":["id","traceId","type","content"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"log","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.type","typeLabel":"string"},"content":{"type":"string","description":"The actual log message for this trace.","example":"Could not find the user with id 123","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.content","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.endTime","typeLabel":"string\u003cdate-time>"},"durationMs":{"description":"Duration of the step in milliseconds","example":334,"type":"integer","minimum":0,"maximum":9007199254740991,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.durationMs","typeLabel":"integer"},"costAmount":{"description":"Cost of the step in the configured currency (primarily for LLM steps)","example":0.0035,"type":"number","minimum":0,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.costAmount","typeLabel":"number"},"status":{"default":"success","description":"Status of the step indicating success or failure. Defaults to 'success'.","example":"success","type":"string","enum":["success","error","timeout","pending"],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.status","typeLabel":"enum\u003cstring>"},"statusCode":{"description":"Status code associated with the step (e.g., HTTP status code for API calls, OTEL status code for traced spans).","example":"200","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.statusCode","typeLabel":"string"},"error":{"description":"Error message or stack trace if the step failed.","example":"TimeoutError: Request timed out after 30s","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9.error","typeLabel":"string"}},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.9","typeLabel":"Log Step · object"},{"type":"object","title":"Group Step","description":"Use this to group multiple steps together, for example a log, llm start, and llm end.","required":["id","traceId","type","key"],"properties":{"id":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID for the step.","example":"123e4567-e89b-12d3-a456-426614174000","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.id","typeLabel":"string\u003cuuid>"},"traceId":{"type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","description":"UUID referencing the parent trace's ID.","example":"610adba1-7cc0-4fa7-9e2b-8bd2fdf281b2","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.traceId","typeLabel":"string\u003cuuid>"},"type":{"type":"string","const":"group","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.type","typeLabel":"string"},"key":{"type":"string","description":"A unique identifier for the grouping, which must be appended to the corresponding steps","example":"inputModeration","isRequired":true,"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.key","typeLabel":"string"},"timestamp":{"description":"When the step was created","example":"2025-01-05T12:34:56.789123Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.timestamp","typeLabel":"string\u003cdate-time>"},"name":{"description":"The name of the step.","example":"Moderation","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.name","typeLabel":"string"},"group":{"description":"Optionally, the key for a group step to group the step with.","example":"inputModeration","type":"string","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.group","typeLabel":"string"},"params":{"oneOf":[{"type":"object","description":"Arbitrary params for the step.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.params.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.params.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.params.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.params.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Arbitrary params for the step.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.params.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.params","typeLabel":"object | any[] | string"},"metadata":{"oneOf":[{"type":"object","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","additionalProperties":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.metadata.oneOf.0.additionalProperties","typeLabel":"any"},"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.metadata.oneOf.0","typeLabel":"object"},{"type":"array","items":{"oneOf":[{}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.metadata.oneOf.1.items.[INDEX]","typeLabel":"any"},"description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.metadata.oneOf.1","typeLabel":"any[]"},{"type":"string","description":"Extra metadata about this trace event. String values are parsed as JSON if possible, otherwise wrapped in { raw: val }.","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.metadata.oneOf.2","typeLabel":"string"}],"uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.metadata","typeLabel":"object | any[] | string"},"parentId":{"description":"Parent step ID for hierarchical span relationships. Links this step to its parent in the trace tree.","example":"456e7890-e89b-12d3-a456-426614174001","type":"string","format":"uuid","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.parentId","typeLabel":"string\u003cuuid>"},"endTime":{"description":"When the step ended (for duration tracking)","example":"2025-01-05T12:34:57.123456Z","type":"string","format":"date-time","pattern":"^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z))$","uniqueKey":"events.items.[INDEX].oneOf.0.steps.items.[INDEX].oneOf.10.endTime","typeLabel":"string\u003cda
[...]
